package Symulacja;

import java.awt.event.*;
import java.util.Random;

import javax.swing.*;
import javax.swing.border.Border;

public class Main extends JFrame{


	public static void main(String[] arg){
	    new Main();
	}

private static final long serialVersionUID = 1L;
private Timer timer;
private Symulacja symulacja;
private JTabbedPane zakladki;
private JButton start;
private JButton koniec;


	public Main(){

		super("Symulacja sieci komrkowej");

		this.initGUI();

		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//this.setResizable(false);

		timer=new Timer(80,new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {

				if(!symulacja.koniecSymulacji()){
				  symulacja.symulujZdarzenie();
				  symulacja.repaint();
				} else{
					start.setText("Start");
					timer.stop();
                    koniec.setVisible(false);
				}
                }


		});

		this.setVisible(true);
	}
    
private void initGUI(){

	this.setSize(1050,700);
	this.setLocation(200,50);

	zakladki=new JTabbedPane();
	this.getContentPane().setLayout(null);
	zakladki.setBounds(400,0,640,650);
	this.getContentPane().add(zakladki);

	symulacja=new Symulacja();
	zakladki.addTab("rysunek",symulacja);
	zakladki.addTab("wykres", symulacja.pobierzWykres());
	zakladki.addTab("dane", new JScrollPane(symulacja.pobierzPanelZDanymi()));

	JPanel panelZdanymi=new JPanel();
	panelZdanymi.setLayout(null);
	panelZdanymi.setBounds(10, 10, 380, 510);
	this.getContentPane().add(panelZdanymi);

	Border borderD =BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "dane wejciowe");
	panelZdanymi.setBorder(borderD);

	start=new JButton("Start");
    koniec=new JButton("Zakocz symulacj");

	JLabel rozmiarL=new JLabel("rozmiar sieci NxN");
    final JTextField rozmiarT=new JTextField("15");

    JLabel kanalyL=new JLabel("liczba kanaw w komrce");
    final JTextField kanalyT=new JTextField("10");

    JLabel abonentL=new JLabel("liczba abonentw");
    final JTextField abonentT=new JTextField("4000");

    JLabel prawdL=new JLabel("prawdopodobiestwo");
    final JTextField prawdT=new JTextField("0.1");

    JLabel krokL=new JLabel("ilo krokw czasowych");
    final JTextField krokT=new JTextField("100");

    JPanel rozkladN=new JPanel();
    rozkladN.setLayout(null);
    Border borderN=BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "parametry rozkadu normalnego");
	rozkladN.setBorder(borderN);

	JLabel sredniaL=new JLabel("rednia");
	final JTextField sredniaT=new JTextField("7");

	JLabel odchylenieL=new JLabel("odchylenie standardowe");
	final JTextField odchylenieT=new JTextField("4");

	JPanel ziarno=new JPanel();
	ziarno.setLayout(null);
	Border borderZ=BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "generator liczb pseudolosowych ");
    ziarno.setBorder(borderZ);
    ButtonGroup bg=new ButtonGroup();
	final JRadioButton bezZiarnaRB=new JRadioButton("bez ziarna",true);
    final JRadioButton zZiarnemRB=new JRadioButton("z ziarnem",false);
    final JTextField ziarnoT=new JTextField("20");
    ziarnoT.setVisible(false);
    bg.add(bezZiarnaRB);
    bg.add(zZiarnemRB);

	rozmiarL.setBounds(30,50,170,25);
	rozmiarT.setBounds(250,50,100,25);
	kanalyL.setBounds(30,80,170,25);
	kanalyT.setBounds(250,80,100,25);
	abonentL.setBounds(30,110,170,25);
	abonentT.setBounds(250,110,100,25);
	prawdL.setBounds(30,140,170,25);
	prawdT.setBounds(250,140,100,25);
	krokL.setBounds(30,170,170,25);
	krokT.setBounds(250,170,100,25);

	ziarno.setBounds(10, 220, 360, 110);
	bezZiarnaRB.setBounds(20,40,120,20);
	zZiarnemRB.setBounds(20,70,120,20);
	ziarnoT.setBounds(240,70,100,25);
	rozkladN.setBounds(10, 355,360,120);
	sredniaL.setBounds(30, 40, 160, 25);
	sredniaT.setBounds(240, 40, 100, 25);
	odchylenieL.setBounds(30, 70, 160, 25);
	odchylenieT.setBounds(240, 70, 100, 25);

	start.setBounds(100,545,150,25);
    koniec.setBounds(100,610,150,25);
    koniec.setVisible(false);

	panelZdanymi.add(rozmiarL);
	panelZdanymi.add(rozmiarT);
	panelZdanymi.add(prawdL);
	panelZdanymi.add(prawdT);
	panelZdanymi.add(krokL);
	panelZdanymi.add(krokT);
	panelZdanymi.add(kanalyL);
	panelZdanymi.add(kanalyT);
	panelZdanymi.add(abonentL);
	panelZdanymi.add(abonentT);
	panelZdanymi.add(rozkladN);
	panelZdanymi.add(ziarno);
	ziarno.add(bezZiarnaRB);
	ziarno.add(zZiarnemRB);
	ziarno.add(ziarnoT);
	rozkladN.add(sredniaL);
	rozkladN.add(sredniaT);
	rozkladN.add(odchylenieL);
	rozkladN.add(odchylenieT);

	this.getContentPane().add(start);
    this.getContentPane().add(koniec);

	start.addActionListener(new ActionListener(){
		@Override
		public void actionPerformed(ActionEvent e) {

         if(start.getText().equals("Start")){
		  boolean flaga=true;
		  String nieprawidlowe="";

		  if(!czyNaturalna(rozmiarT.getText(),true)){flaga=false; nieprawidlowe+="rozmiar sieci\n";}
		  if(!czyNaturalna(kanalyT.getText(),true)){flaga=false; nieprawidlowe+="liczba kanaw w sieci\n";}
		  if(!czyNaturalna(abonentT.getText(),true)){flaga=false; nieprawidlowe+="liczba abonentw\n";}
		  if(!czyRzeczywistaDodatnia(prawdT.getText())){flaga=false; nieprawidlowe+="prawdopodobiestwo rozpoczcia przez abonenta rozmowy\n";}
		  if(!czyNaturalna(krokT.getText(),false)){flaga=false; nieprawidlowe+="ilo krokw czasowych\n";}
		  if(!czyNaturalna(ziarnoT.getText(),false)){flaga=false; nieprawidlowe+="warto ziarna\n";}
		  if(!czyRzeczywistaDodatnia(sredniaT.getText())){flaga=false; nieprawidlowe+="rednia\n";}
		  if(!czyRzeczywistaDodatnia(odchylenieT.getText())){flaga=false; nieprawidlowe+="odchylenie standardowe\n";}



		  if(flaga){
              if(Integer.parseInt(rozmiarT.getText())>50){ nieprawidlowe+="rozmiar sieci nie moe by wikszy od 50\n"; flaga=false;}
			  if(Double.parseDouble(prawdT.getText())>1){ nieprawidlowe+="prawdopodobiestwo rozpoczecia rozmowy przez abonenta  nie moe by wiksze od 1\n"; flaga=false;}
		      if(Double.parseDouble(sredniaT.getText())<=Double.parseDouble(odchylenieT.getText())){
		    	  nieprawidlowe+="srednia musi wysza od odchylenia standardowego\n"; flaga=false;
		      }
		  }

		  if(flaga){
		  int roz=Integer.parseInt(rozmiarT.getText());
		  double prawd=Double.parseDouble(prawdT.getText());
		  int krok=Integer.parseInt(krokT.getText());
		  int kanaly=Integer.parseInt(kanalyT.getText());
		  int abonent=Integer.parseInt(abonentT.getText());

		  double srednia=Double.parseDouble(sredniaT.getText());
		  double odchylenie=Double.parseDouble(odchylenieT.getText());

		  Symulacja.setOdchylenie(odchylenie);
		  Symulacja.setSrednia(srednia);

		  Random random=new Random();
		  if(zZiarnemRB.isSelected()){
			  int ziar=Integer.parseInt(ziarnoT.getText());
			  random.setSeed((long)ziar);
              System.out.println("Z ziarnem "+ziar);
		  }
		  Symulacja.setRandom(random);
		  symulacja.nowaSymulacja(roz,kanaly,abonent, prawd, krok);
		  symulacja.repaint();
		  timer.start();
          start.setText("Wstrzymaj");
           koniec.setVisible(true);
		 // start.setEnabled(false);
		}else{
			JOptionPane.showMessageDialog(null,"Nastpujce pola maj nieprawidowe wartoci:\n\n"+nieprawidlowe);
		}
         }else if(start.getText().equals("Wstrzymaj")){
             start.setText("Wznw");
             timer.stop();
         }else if(start.getText().equals("Wznw")){
             start.setText("Wstrzymaj");
             timer.start();
         }

		}
	});


    koniec.addActionListener(new ActionListener(){
	      @Override
            public void actionPerformed(ActionEvent e) {
              symulacja.zakoncz();
              timer.stop();
              start.setText("Start");
              koniec.setVisible(false);
            }
    
    });

	bezZiarnaRB.addActionListener(new ActionListener(){
		@Override
		public void actionPerformed(ActionEvent e) {
			if(bezZiarnaRB.isSelected()) ziarnoT.setVisible(false);
		}

	});

	zZiarnemRB.addActionListener(new ActionListener(){
		@Override
		public void actionPerformed(ActionEvent e) {
			if(zZiarnemRB.isSelected()) ziarnoT.setVisible(true);
		}

	});
}

private boolean czyNaturalna(String s,boolean f){
	try{
		boolean flaga=false;
		if(s==null || (s.trim()).length()==0 )
			flaga=false;
		else if(f && Integer.parseInt(s) > 0) flaga= true;
		else if(!f && Integer.parseInt(s) > -1) flaga= true;

	    return flaga;
	}catch(Exception e){return false;}
}

private boolean czyRzeczywistaDodatnia(String s){
	try{
		boolean flaga=false;
		if(s==null || (s.trim()).length()==0 )
			flaga=false;
		else if(Double.parseDouble(s) > 0) flaga= true;

	    return flaga;
	}catch(Exception e){return false;}
}

}
