package Symulacja;

import java.awt.*;
import java.text.NumberFormat;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Random;

import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTextArea;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;

import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class Symulacja extends JPanel{


private static final long serialVersionUID = 1L;
private int ileKrokow;
private int liczbaKrokow;
private static int rozmiar;
private JProgressBar pasekPostepu;

public static int getRozmiar() {
	return rozmiar;
}

public static void setRozmiar(int rozmiar) {
	Symulacja.rozmiar = rozmiar;
}

private boolean koniec;
private Komorka[] komorki;
private JFreeChart wykres;
private JTextArea dane;
private static Random random;
private static double srednia;
private static double odchylenie;
private XYSeries wspolrzedne;
private NumberAxis wspoX;
private NumberFormat numberFormat;

	public Symulacja(){
		super();
		rozmiar=0;
		koniec=true;
		komorki=new Komorka[0];
	    dane=new JTextArea();
        numberFormat=NumberFormat.getNumberInstance(Locale.GERMANY);
        numberFormat.setMaximumFractionDigits(2);
	    this.stworzWykres();
        pasekPostepu=new JProgressBar();
        pasekPostepu.setMinimum(0);
        pasekPostepu.setStringPainted(true);
        pasekPostepu.setBounds(125,585,400,25);
        pasekPostepu.setVisible(false);
        this.setLayout(null);
        this.add(pasekPostepu);
	}

	private void stworzWykres(){
		this.wspolrzedne=new XYSeries("Stopie wykorzystania kanaw (%)");
		XYSeriesCollection dataset = new XYSeriesCollection();
		dataset.addSeries(wspolrzedne);
		wykres=ChartFactory.createXYLineChart("Stopie wykorzystania wszystkich kanaw w sieci", "Czas", "Wykorzystane kanay (%)", dataset, PlotOrientation.VERTICAL, true, true, false);
		wykres.setBorderPaint(Color.WHITE);
        

	    final XYPlot plot = wykres.getXYPlot();
	 	//plot.setBackgroundPaint(Color.lightGray);
		plot.setDomainGridlinePaint(Color.white);
		plot.setRangeGridlinePaint(Color.white);

        final NumberAxis y=(NumberAxis)plot.getRangeAxis();
        y.setRange(0,105);
 
        wspoX=(NumberAxis)plot.getDomainAxis();
        wspoX.setRange(0,100);
   

        XYLineAndShapeRenderer renderer=(XYLineAndShapeRenderer) plot.getRenderer();
        renderer.setSeriesPaint(0, Color.BLACK);

	}

	public void nowaSymulacja(int n,int kan,int abonenci,double p, int k){

		Symulacja.setRozmiar(n);
		this.komorki=new Komorka[rozmiar*rozmiar];
		this.liczbaKrokow=k;
		this.ileKrokow=k;
		Komorka.setKanaly(kan);
		Komorka.setPrawd(p);


		int l=Symulacja.losujInt(rozmiar*rozmiar);
        int abonenciRozmawiajacy=Symulacja.losujInt(abonenci);

		for(int i=0;i<rozmiar*rozmiar;i++)komorki[i]=new Komorka(i);
		for(int i=0;i<abonenci;i++){
           Abonent ab=new Abonent();
		    if(abonenciRozmawiajacy>0){
		      ab.zacznijRozmawiac();
		      abonenciRozmawiajacy--;
		    }
		    komorki[l].dodajAbonenta(ab);
		}

		if(this.liczbaKrokow>0)koniec=false;

		dane.setText("");
		dane.append("Rozmiar sieci: "+Symulacja.getRozmiar()+"x"+Symulacja.getRozmiar()+"\n");
		dane.append("Liczba kanaw w komrce: "+Komorka.getKanaly()+"\n");
		dane.append("Liczba abonentw: "+abonenci+"\n");
		dane.append("Liczba abonentw rozmawiajcych: "+abonenciRozmawiajacy+"\n");
		dane.append("Prawdopodobiestwo rozpoczcia przez abonenta rozmowy w danej chwili czasowej: "+Komorka.getPrawd()+"\n");
		dane.append("Liczba krokw czasowych trwania symulacji: "+this.ileKrokow+"\n");
		dane.append("Parametry rozkadu normalnego:\n");
		dane.append("1) rednia: "+Symulacja.getSrednia()+"\n");
		dane.append("2) Odchylenie standardowe: "+Symulacja.getOdchylenie()+"\n\n\n");

        this.pasekPostepu.setMaximum(this.liczbaKrokow);
        pasekPostepu.setVisible(true);

	   this.wspolrzedne.clear();
       int x=this.liczbaKrokow;
       if(x>50)x=(int)Math.floor(this.liczbaKrokow*1.05+0.5);
       this.wspoX.setRange(0,x);

	}
	public JPanel pobierzWykres(){

		 return new ChartPanel(wykres);
	}
	public JTextArea pobierzPanelZDanymi(){
		return this.dane;
	}

	public void symulujZdarzenie(){

        for(int i=0; i<komorki.length; i++){ // zdarzenie rozpoczecia rozmowy
			komorki[i].symulujZdarzenie();
		}
        System.out.println();

     this.wykorzystanieKanalow(); // obliczam stopien wykorzystania kanalow


      for(int i=0; i<komorki.length; i++){ // zdarzenie rozpoczecia rozmowy
			komorki[i].wyznaczAbonentowKtorzyChcaZmienicKomorke();
		}
     
		for(int i=0;i<komorki.length; i++){ // zdarzenia przejscia
		   List<Abonent> lista=komorki[i].przejdzDoKomorki();
		   Iterator<Abonent> iter=lista.iterator();
		     while(iter!=null && iter.hasNext()){
		    	Abonent ab=iter.next();
		    	komorki[ab.getPrzejscie()].dodajAbonenta(ab);
		     }
		}

	  
		pasekPostepu.setValue(liczbaKrokow-ileKrokow+1);
      
        if(ileKrokow>1)ileKrokow--;
		 else koniec=true;
        
	}

	public boolean koniecSymulacji(){
		return koniec;
	}

	public void paintComponent(Graphics g){

		Graphics2D g2=(Graphics2D)g;
		g2.setColor(Color.WHITE);
		g2.fillRect(-1, -1, this.getWidth()+1, this.getHeight()+1);


		if(Symulacja.getRozmiar()>0){

		int xy=this.getWidth();
		if(xy>this.getHeight())xy=this.getHeight();

		double a= xy/(Symulacja.getRozmiar());// dlugosc boku szesciokata
		       a*=0.34;

		int[] xp=new int[6];
		int[] yp=new int[6];

		double h=(a*Math.pow(3,0.5)/2);

		xy-=40;

		h=xy/(Symulacja.getRozmiar()+0.5);
		h/=2;
		a=(2*h)/Math.sqrt(3);

		for(int i=0;i<Symulacja.getRozmiar();i++){
		   for(int j=0;j<Symulacja.getRozmiar();j++){

			 double stalax=(this.getWidth()-(Symulacja.getRozmiar()*2*h +h))/2 + j*2*h;
			 double stalay=(this.getHeight()-(Symulacja.getRozmiar()*1.5*a)-0.5*a)/2 + i*1.5*a;

			 if(i%2==1)stalax+=h;

			  xp[0]=(int)Math.floor(stalax + 0.5);
			  xp[1]=(int)Math.floor(stalax + h + 0.5);
			  xp[2]=(int)Math.floor(stalax + 2*h + 0.5);
			  xp[3]=(int)Math.floor(stalax + 2*h + 0.5);
			  xp[4]=(int)Math.floor(stalax + h + 0.5);
			  xp[5]=(int)Math.floor(stalax + 0.5);

			  yp[0]=(int)Math.floor(stalay + 0.5*a + 0.5) ;
			  yp[1]=(int)Math.floor(stalay + 0.5) ;
			  yp[2]=(int)Math.floor(stalay + 0.5*a + 0.5) ;
			  yp[3]=(int)Math.floor(stalay + 1.5*a + 0.5) ;
			  yp[4]=(int)Math.floor(stalay + 2*a + 0.5) ;
			  yp[5]=(int)Math.floor(stalay + 1.5*a + 0.5) ;

			  Polygon p=new Polygon(xp,yp,6);

			  g2.setColor(Color.cyan);
			  g2.fillPolygon(p);
			  g2.setColor(Color.BLACK);
			  g2.drawPolygon(p);


			  g2.setColor(Color.BLUE);
			  g2.fillRect(400, 15, 3, 3);
			  g2.drawString("- abonenci rozmawiajcy", 410, 20);
			  int k=komorki[(i*Symulacja.getRozmiar())+j].liczbaAbonentowRozmawiajacych();
			//  System.out.println("komorka "+((i*Symulacja.getRozmiar())+j)+" abonentow "+k);
			  for(int m=0;m<k;m++){
				  Point punkt=this.pozycjaAbonenta(new Point((int)(stalax + h),(int)(stalay + a)), (int)h, (int)a);
				  g2.fillRect(punkt.x, punkt.y, 3, 3);
			  }


			  g2.setColor(Color.RED);
			  g2.fillRect(400, 35, 3, 3);
			  g2.drawString("- abonenci nierozmawiajcy", 410, 40);
			  k=komorki[(i*Symulacja.getRozmiar())+j].liczbaAbonentowNierozmawiajacych();
			//  System.out.println("komorka "+((i*Symulacja.getRozmiar())+j)+" abonentow "+k);
			  for(int m=0;m<k;m++){
				  Point punkt=this.pozycjaAbonenta(new Point((int)(stalax + h),(int)(stalay + a)), (int)h, (int)a);
				  g2.fillRect(punkt.x, punkt.y, 3, 3);
			  }

			 }

		}

	  }
	}


private Point pozycjaAbonenta(Point p, int h,int a){
		// punkt p - srodek komorki

		int x=Symulacja.losujInt(2*h);
		int y=Symulacja.losujInt(2*a);
		Point punkt=new Point();

		if(y<0.5*a || y>1.5*a){
		 int yy=0;
		   do{
			   x=Symulacja.losujInt(2*h);
			   yy=(int)(0.5*a);
			   if(y>1.5*a) yy=(int)(1.5*a);

		   }while(!odpowiednieWspolrzedne(x-h, y-yy, a, h));
		}

		punkt.x+=p.x + x -h;
        punkt.y+=p.y + y -a;

		return punkt;
}

private boolean odpowiednieWspolrzedne(int x, int y, int a, int h){
 boolean flaga=false;
   // 4 mozliwosci
  double b=0.5*a;
  double aa= (-b)/(-h);

 // System.out.println(a+ " "+h+" "+x+" "+y+" "+aa+" "+b );
 if(x<=0 && y>=0){
	 if(y <= aa*x+b) flaga=true;

 }else if(x>=0 && y>=0){
	 aa=(-b)/(h);
	 if(y <= aa*x+b) flaga=true;

 }
 else if(x<=0 && y<=0){
	 b*=-1;
	 aa=(-b)/(-h);
	 if(y >= aa*x+b) flaga=true;

 }

 else if(x>=0 && y<=0){
	 b*=-1;
	 aa=(-b)/(h);
	 if(y >= aa*x+b) flaga=true;
 }
 else {
	 flaga=true;
 }


 return flaga;
}

public static void setRandom(Random r){
	Symulacja.random=r;
}

public static int losujInt(int a){

	return random.nextInt(a);

}

public static double losujDouble(){
 
    return random.nextDouble();
}

public static int losujZrozkladuNormalnego(){
	double d=random.nextGaussian();
    d=(Symulacja.getSrednia()+ (Symulacja.getOdchylenie()*d));
    //System.out.println((int)(Math.floor(d+0.5)));
    int k=(int)(Math.floor(d+0.5));
    if(k<1)k=Symulacja.losujZrozkladuNormalnego();
	return k;
}

public static double getSrednia() {
	return srednia;
}

public static void setSrednia(double srednia) {
	Symulacja.srednia = srednia;
}

public static double getOdchylenie() {
	return odchylenie;
}

public static void setOdchylenie(double odchylenie) {
	Symulacja.odchylenie = odchylenie;
}

private void wykorzystanieKanalow(){
	double suma=0;
	for(int i=0;i<komorki.length;i++){
		suma+=komorki[i].liczbaAbonentowRozmawiajacych();
	}
	double srednia=(suma*100)/(komorki.length*Komorka.getKanaly());

 dane.append("--------------------Iteracja nr: "+(liczbaKrokow-ileKrokow+1)+"--------------------\n");
 dane.append("Liczba abonentw rozmawiajcych w caej sieci: "+suma+"\n");
 dane.append("Stopie wykorzystania kanaw: "+numberFormat.format(srednia)+"%\n");
 dane.append("\n");

this.wspolrzedne.add(liczbaKrokow-ileKrokow,srednia);


}


public void zakoncz(){
   this.pasekPostepu.setVisible(false);
   this.ileKrokow=this.liczbaKrokow+1;
   this.wspolrzedne.clear();
   Symulacja.setRozmiar(0);
   dane.setText("");
   this.repaint();
}
}

